import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * @Author: Diana Mei Leng Wong Michiko Chand Nazih Ajami
 * @Date: November 15, 2006
 * 
 * Description:
 * 
 */


public class Nomination {

	static Calendar cal = new GregorianCalendar();

	private static int year = cal.get(Calendar.YEAR);

	private static int month = cal.get(Calendar.MONTH) + 1;

	private static int day = cal.get(Calendar.DAY_OF_MONTH);
	
	private static String date = (String) ("" + month + "/" + day + "/" + year);
	
	static ResultSet rsNom = null;
	
	// ---testing
	public static void main(String[] args) throws SQLException {

		getNomination("Employee of the Month");
		new Nomination(1, 1, 7, 40, "He is Good");
	}
	
	public  Nomination(int awardID, int groupID, int nominatedEmpID,
			int nominationByEmpID, String nominationComment)
			throws SQLException {

		String sqlInsert;

		ConnectToDB.createConnection();

		sqlInsert = "Insert INTO [Nomination](awardID, groupID, awardDate, nominatedEmpID, nominationByEmpID, nominationDate, nominationComment)"
				+ "SELECT "
				+ awardID
				+ ", "
				+ groupID
				+ ", '"
				+ date
				+ "', "
				+ nominatedEmpID
				+ ", "
				+ nominationByEmpID
				+ ", '"
				+ date
				+ "', '"
				+ nominationComment + "'";

		System.out.println(sqlInsert);
		
		ConnectToDB.runQuery(sqlInsert);

		System.out.println("Done");

		ConnectToDB.closeConnection();
	}

	public Nomination(String awardName, String groupName,
			String nominatedEmpName, String nominationByEmpName,
			String nominationComment) throws SQLException {

		int groupID, awardID, nominatedEmpID, nominationByEmpID;

		groupID = Group.getGroupID(groupName);
		awardID = Award.getAwardID(awardName);

		nominatedEmpID = Employee.getEmpID(nominatedEmpName);

		nominationByEmpID = Employee.getEmpID(nominationByEmpName);

		new Nomination(awardID, groupID, nominatedEmpID, nominationByEmpID,
				nominationComment);
	}

	public static void getNomination(String awardName) throws SQLException {

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT nominatedName, nominationDate, nominationComment, nominatedByName "
				+ " FROM [NominationInfo] "
				+ " WHERE awardName = '"
				+ awardName + "'";

		ConnectToDB.setQuery(sqlSelect);

		rsNom = ConnectToDB.resultSet;

	}

	public static void getNomination(String awardName, String nominatedName)
			throws SQLException {

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT NominationInfo.nominatedName, NominationInfo.nominationDate, NominationInfo.nominationComment, NominationInfo.nominatedByName "
				+ " FROM [NominationInfo] "
				+ " WHERE awardName = '"
				+ awardName
				+ "'"
				+ " AND nominatedName = '"
				+ nominatedName
				+ "'";

		ConnectToDB.setQuery(sqlSelect);
	}

	public static String[] getNominationEmpName(String awardName)
			throws SQLException {

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT  DISTINCT nominatedName "
				+ " FROM [NominationInfo] " + " WHERE awardName = '"
				+ awardName + "'";

		ConnectToDB.setQuery(sqlSelect);

		String[] NominatedList = new String[ConnectToDB.numberOfRows + 1];

		NominatedList = ConnectToDB.getList();

		ConnectToDB.closeConnection();

		return NominatedList;
	}

}
