import java.sql.SQLException;
import java.util.Calendar;
import java.util.GregorianCalendar;

/**
 * @Author: Diana Mei Leng Wong Michiko Chand Nazih Ajami
 * @Date: November 15, 2006
 * 
 * Description:
 * 
 */

public class Vote {

	Calendar cal = new GregorianCalendar();

	int year = cal.get(Calendar.YEAR);

	int month = cal.get(Calendar.MONTH) + 1;

	int day = cal.get(Calendar.DAY_OF_MONTH);

	private static int awardID = 0;

	public Vote(String awardName, int groupID, int nominatedEmpID,
			int votedByEmpID) throws SQLException {

		String sqlInsert;
		String bqlInsert;
		String cqlSelect;
		// awardID = 4; this has to be there just for display purposes

		String date = (String) ("" + month + "/" + day + "/" + year);

		ConnectToDB.createConnection();

		sqlInsert = "INSERT INTO [Vote](nominatedEmpID, awardID, groupID, awardDate, votedByEmpID, voteDate)"
				+ " SELECT "
				+ nominatedEmpID
				+ " AS nominatedEmpID, "
				+ awardID
				+ " AS awardID, "
				+ groupID
				+ " AS groupID, '"
				+ date
				+ "' AS awardDate, "
				+ votedByEmpID
				+ " AS votedByEmpID, '"
				+ date + "' AS voteDate";

		bqlInsert = "INSERT INTO Sample(awardID, Name, Add) VALUES (4, 'ryan', 'CA')";

		System.out.println(bqlInsert);
		ConnectToDB.runQuery(bqlInsert);

		System.out.println(sqlInsert);
		ConnectToDB.runQuery(sqlInsert);

		cqlSelect = "SELECT * FROM Vote";
		ConnectToDB.setQuery(cqlSelect);
	}

	public Vote(String awardName, String groupName, String nominatedEmpName,
			String votedByEmpName) throws SQLException {

		int groupID, nominatedEmpID, votedByEmpID;

		groupID = Group.getGroupID(groupName);

		nominatedEmpID = Employee.getEmpID(nominatedEmpName);

		awardID = Award.getAwardID(awardName);

		votedByEmpID = Employee.getEmpID(votedByEmpName);

		System.out.println(awardID);
		new Vote(awardName, groupID, nominatedEmpID, votedByEmpID);

	}

	// ---testing
	public static void main(String[] args) throws SQLException {

		new Vote("Seven Attributes - Fun and Pleasant", 1, 1, 2);
		new Vote("Seven Attributes - Sense of Urgency",
				"Commercial Markets Group", "Allen, Cleet",
				"Ajami, Nazih (Nino)");

	}
}
